import express from 'express'

export interface QuestionData {
  type: string
  images?: Array<string>
  hashedImages?: Array<string>
}

export interface Question {
  Q: string
  A: string
  data: QuestionData
  cache?: {
    Q: Array<string>
    A: Array<string>
  }
}

export interface Subject {
  Name: string
  Questions: Array<Question>
}

export interface DataFile {
  path: string
  name: string
  locked?: Boolean
  shouldSearch:
    | string
    | {
        location?: {
          val: string
        }
      }
  shouldSave: {
    location?: {
      val: string
    }
    version?: {
      compare: string
      val: string
    }
  }
}

export interface QuestionDb extends DataFile {
  data: Array<Subject>
  index: number
}

export interface User {
  id: number
  pw: string
  created: Date
}

export interface ModuleType {
  app: express.Application
  dailyAction?: Function
}

export interface User {
  id: number
  pw: string
  pwRequestCount: number
  avaiblePWRequests: number
  loginCount: number
  createdBy: number
}

export interface Request extends express.Request {
  cookies: any
  session: any
  busboy: any
  files: any
}

export interface SubmoduleData {
  app: express.Application
  url: string
  publicdirs: Array<string>
  userDB?: any
  nextdir?: string
  httpServer: any
  moduleSpecificData?: any
  httpsServer?: any
}
